# Upbit Open API
#
# ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
#
# OpenAPI spec version: 1.0.0
# Contact: ujhin942@gmail.com
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' OrderbookUnit Class
#'
#' @field ask_price 
#' @field bid_price 
#' @field ask_size 
#' @field bid_size 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
OrderbookUnit <- R6::R6Class(
  'OrderbookUnit',
  public = list(
    `ask_price` = NULL,
    `bid_price` = NULL,
    `ask_size` = NULL,
    `bid_size` = NULL,
    initialize = function(`ask_price`, `bid_price`, `ask_size`, `bid_size`){
      if (!missing(`ask_price`)) {
        stopifnot(is.numeric(`ask_price`), length(`ask_price`) == 1)
        self$`ask_price` <- `ask_price`
      }
      if (!missing(`bid_price`)) {
        stopifnot(is.numeric(`bid_price`), length(`bid_price`) == 1)
        self$`bid_price` <- `bid_price`
      }
      if (!missing(`ask_size`)) {
        stopifnot(is.numeric(`ask_size`), length(`ask_size`) == 1)
        self$`ask_size` <- `ask_size`
      }
      if (!missing(`bid_size`)) {
        stopifnot(is.numeric(`bid_size`), length(`bid_size`) == 1)
        self$`bid_size` <- `bid_size`
      }
    },
    toJSON = function() {
      OrderbookUnitObject <- list()
      if (!is.null(self$`ask_price`)) {
        OrderbookUnitObject[['ask_price']] <- self$`ask_price`
      }
      if (!is.null(self$`bid_price`)) {
        OrderbookUnitObject[['bid_price']] <- self$`bid_price`
      }
      if (!is.null(self$`ask_size`)) {
        OrderbookUnitObject[['ask_size']] <- self$`ask_size`
      }
      if (!is.null(self$`bid_size`)) {
        OrderbookUnitObject[['bid_size']] <- self$`bid_size`
      }

      OrderbookUnitObject
    },
    fromJSON = function(OrderbookUnitJson) {
      OrderbookUnitObject <- jsonlite::fromJSON(OrderbookUnitJson)
      if (!is.null(OrderbookUnitObject$`ask_price`)) {
        self$`ask_price` <- OrderbookUnitObject$`ask_price`
      }
      if (!is.null(OrderbookUnitObject$`bid_price`)) {
        self$`bid_price` <- OrderbookUnitObject$`bid_price`
      }
      if (!is.null(OrderbookUnitObject$`ask_size`)) {
        self$`ask_size` <- OrderbookUnitObject$`ask_size`
      }
      if (!is.null(OrderbookUnitObject$`bid_size`)) {
        self$`bid_size` <- OrderbookUnitObject$`bid_size`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "ask_price": %d,
           "bid_price": %d,
           "ask_size": %d,
           "bid_size": %d
        }',
        self$`ask_price`,
        self$`bid_price`,
        self$`ask_size`,
        self$`bid_size`
      )
    },
    fromJSONString = function(OrderbookUnitJson) {
      OrderbookUnitObject <- jsonlite::fromJSON(OrderbookUnitJson)
      self$`ask_price` <- OrderbookUnitObject$`ask_price`
      self$`bid_price` <- OrderbookUnitObject$`bid_price`
      self$`ask_size` <- OrderbookUnitObject$`ask_size`
      self$`bid_size` <- OrderbookUnitObject$`bid_size`
    }
  )
)
